//+------------------------------------------------------------------+
//|                                                  Fibonacci_R.mq4 |
//|                                      Copyright  2008, forexlion |
//|                                          http://www.anchorfx.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, forexlion"
#property link      "http://www.anchorfx.com"

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
ObjectsDeleteAll();

   double sr[10], CD;
   string slr[10];

      CD = iClose(Symbol(),PERIOD_D1,1);
      drawLine(CD,DoubleToStr(CD,4),Green,1);
      drawLabel("Daily",CD,Green);
   
   double AA = 8;
   double BB = 13;
   double CC;
   for (int i=ArraySize(sr);i>=0;i--)
   {
      CC = AA + BB;
      sr[i] = CD - CC * Point;
      slr[i] = "- "+DoubleToStr(CC,0); 
      AA = BB;
      BB = CC;
   }

   for (i=ArraySize(sr);i>=0;i--)
   {
      drawLine(sr[i],DoubleToStr(sr[i],4),Green,1);
      drawLabel(slr[i],sr[i],Green);
   }

   AA = 8;
   BB = 13;
   CC = 0;
   for (i=ArraySize(sr);i>=0;i--)
   {
      CC = AA + BB;
      sr[i] = CD + CC * Point;
      slr[i] = "+ "+DoubleToStr(CC,0); 
      AA = BB;
      BB = CC;
   }
   for (i=ArraySize(sr);i>=0;i--)
   {
      drawLine(sr[i],DoubleToStr(sr[i],4),Green,1);
      drawLabel(slr[i],sr[i],Green);
   }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 8, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}


void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}