//+------------------------------------------------------------------+
//|                                                  Fibo_Series.mq4 |
//|                                                         MicroMan |
//|                                                         Fish.net |
//+------------------------------------------------------------------+
#property copyright "MicroMan"
#property link      "Fish.net" 
#property  indicator_chart_window
//+------------------------------------------------------------------+
//|   Fibo_Series_Indicator.mq4  by Micro-MiniMe
//+------------------------------------------------------------------+

extern bool Monthly = False;
extern bool Weekly  = False; 
extern bool Daily   = True;
extern string comment = "per choices: 0=future daily close 1=current 2=past";
extern int  per = 1;// 1= used for current period fib series, 0= used for tomorrows series, 2= yesterdays series
extern color lineColor = Green;// used for lines and text

int deinit()
{  
   ObjectDelete("CloseLine");
   ObjectDelete("CloseLabel");   
   ObjectDelete("up34Line");
   ObjectDelete("up34Label");
   ObjectDelete("up55Line");
   ObjectDelete("up55Label");  
   ObjectDelete("up89Line");
   ObjectDelete("up89Label");
   ObjectDelete("up144Line");
   ObjectDelete("up144Label");   
   ObjectDelete("up233Line");
   ObjectDelete("up233Label");
   ObjectDelete("up377Line");
   ObjectDelete("up377Label");

   ObjectDelete("down34Line");
   ObjectDelete("down34Label");
   ObjectDelete("down55Line");
   ObjectDelete("down55Label");  
   ObjectDelete("down89Line");
   ObjectDelete("down89Label");
   ObjectDelete("down144Line");
   ObjectDelete("down144Label");   
   ObjectDelete("down233Line");
   ObjectDelete("down233Label");
   ObjectDelete("down377Line");
   ObjectDelete("down377Label");               
   return(0);
}
//+------------------------------------------------------------------+
//+-------------------Start Function---------------------------------+
int start()
{
   int CalcPeriod;
	string pLineStr,S1LineStr,R1LineStr,S2LineStr,R2LineStr,S3LineStr,R3LineStr;
	string S4LineStr,R4LineStr,S5LineStr,R5LineStr,S6LineStr,R6LineStr;
      S1LineStr = " -34  ";
      R1LineStr = " +34  ";
      S2LineStr = " -55  ";
      R2LineStr = " +55  ";
      S3LineStr = " -89  ";
      R3LineStr = " +89  ";      
      S4LineStr = " -144  ";
      R4LineStr = " +144  ";
      S5LineStr = " -233  ";
      R5LineStr = " +233  ";
      S6LineStr = " -377  ";
      R6LineStr = " +377  "; 
   if(Monthly == True)
   { 
      CalcPeriod = 43200;
      pLineStr = "Monthly Close ";           
   }
   if(Weekly == True)
   {
      CalcPeriod = 10080;
      pLineStr = "Weekly Close ";     
   }
   if(Daily == True)
   {
      CalcPeriod = 1440;
      pLineStr = "Daily Close ";      
   }
   DrawLines(CalcPeriod,pLineStr,S1LineStr,R1LineStr,S2LineStr,R2LineStr,S3LineStr,R3LineStr,S4LineStr,R4LineStr,S5LineStr,R5LineStr,S6LineStr,R6LineStr);   
   return(0);
}   

////////////////Draw Daily Close Line and +/- Lines/Labels/////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////// 
int DrawLines(int CalcPeriod,string pLineStr,string S1LineStr,string R1LineStr,string 
               S2LineStr,string R2LineStr,string S3LineStr,string R3LineStr,string S4LineStr,string R4LineStr,string 
               S5LineStr,string R5LineStr,string S6LineStr,string R6LineStr) 
{
   int shift,dow; 
	string dowStr,cpStr,cp,down34Str,down34,up34Str,up34,down55Str,down55,up55Str,up55,down89Str,down89,up89Str,up89;
	string down144Str,down144,up144Str,up144,down233Str,down233,up233Str,up233,down377Str,down377,up377Str,up377;	
	double ClosePrice,u34,u55,u89,u144,u233,u377,d34,d55,d89,d144,d233,d377;
   shift	= iBarShift(NULL,CalcPeriod,Time[0])+per;	// default = one period ago	 
	datetime StartTime	= iTime(NULL,CalcPeriod,shift);	 
	dow = TimeDayOfWeek(StartTime);
	 switch(dow)
	 {
	  case 5:	 
      dowStr = "Fridays  ";
      break;
    case 0:
      shift	= iBarShift(NULL,CalcPeriod,Time[0])+per+1;	// two periods ago	 
      dowStr = "Fridays  ";     
      break;
    case 1:
      dowStr = "Mondays  ";
      break;
    case 2:
      dowStr = "Tuesdays  ";
      break;
    case 3:
      dowStr = "Wednesdays  ";
      break;
    case 4:
      dowStr = "Thursdays  "; 
      break; 
   } 	 
   if(Monthly==true || Weekly==true)dowStr="";
 	ClosePrice  = NormalizeDouble(iClose(NULL,CalcPeriod,shift),4);
   
   u34 = ClosePrice+34*Point;
   u55 = ClosePrice+55*Point;
   u89 = ClosePrice+89*Point;
   u144 = ClosePrice+144*Point; 
   u233 = ClosePrice+233*Point;
   u377 = ClosePrice+377*Point;
   d34 = ClosePrice-34*Point;
   d55 = ClosePrice-55*Point;
   d89 = ClosePrice-89*Point;
   d144 = ClosePrice-144*Point; 
   d233 = ClosePrice-233*Point;
   d377 = ClosePrice-377*Point; 
     
   cpStr = DoubleToStr(ClosePrice,4);
   cp = StringSubstr(cpStr,0,6); 
 
   down34Str = DoubleToStr(d34,4);
   down34 = StringSubstr(down34Str,0,6);

   down55Str = DoubleToStr(d55,4);
   down55 = StringSubstr(down55Str,0,6);
   
   down89Str = DoubleToStr(d89,4);
   down89 = StringSubstr(down89Str,0,6);

   down144Str = DoubleToStr(d144,4);
   down144 = StringSubstr(down144Str,0,6);

   down233Str = DoubleToStr(d233,4);
   down233 = StringSubstr(down233Str,0,6);

   down377Str = DoubleToStr(d377,4);
   down377 = StringSubstr(down377Str,0,6); 
   
   up34Str = DoubleToStr(u34,4);
   up34 = StringSubstr(up34Str,0,6);

   up55Str = DoubleToStr(u55,4);
   up55 = StringSubstr(up55Str,0,6);
   
   up89Str = DoubleToStr(u89,4);
   up89 = StringSubstr(up89Str,0,6);

   up144Str = DoubleToStr(u144,4);
   up144 = StringSubstr(up144Str,0,6);

   up233Str = DoubleToStr(u233,4);
   up233 = StringSubstr(up233Str,0,6);

   up377Str = DoubleToStr(u377,4);
   up377 = StringSubstr(up377Str,0,6);     
////////////////////Daily Close Line///////////////////////////  
/////////////////////////////////////////////////////////      
 if(ObjectFind("CloseLine")==-1)
  {  
   ObjectCreate("CloseLine", OBJ_HLINE,0, Time[14],ClosePrice);
   ObjectSet("CloseLine", OBJPROP_COLOR, lineColor);
   ObjectSet("CloseLine", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("CloseLine", OBJPROP_WIDTH, 3);
  }
 else
  {
   ObjectMove("CloseLine",0,Time[14],ClosePrice);
  }
 if(ObjectFind("CloseLabel") == -1)
  {
   ObjectCreate("CloseLabel", OBJ_TEXT, 0, Time[14], ClosePrice);
   ObjectSetText("CloseLabel",dowStr+pLineStr+ cp, 10, "Arial",lineColor);
   ObjectSet("CloseLabel",OBJPROP_BACK,false);   
  }
 else
  {
   ObjectMove("CloseLabel", 0, Time[14], ClosePrice);
   ObjectSetText("CloseLabel",dowStr+pLineStr+ cp, 10, "Arial",lineColor);
   ObjectSet("CloseLabel",OBJPROP_BACK,false);    
  
  } 
//////////////////// down34 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("down34Line")==-1)
  {
   ObjectCreate("down34Line", OBJ_HLINE,0, Time[14],d34);
   ObjectSet("down34Line", OBJPROP_COLOR, lineColor);
   ObjectSet("down34Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("down34Line",0,Time[14],d34);
  }
 if(ObjectFind("down34Label") == -1)
  {
   ObjectCreate("down34Label", OBJ_TEXT, 0, Time[14], d34);
   ObjectSetText("down34Label",S1LineStr+ down34, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("down34Label", 0, Time[14], d34);
   ObjectSetText("down34Label",S1LineStr+ down34, 10, "Arial", lineColor);   
  }
/////////////////////up34 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("up34Line")==-1)
  {
   ObjectCreate("up34Line", OBJ_HLINE,0, Time[14],u34);
   ObjectSet("up34Line", OBJPROP_COLOR, lineColor);
   ObjectSet("up34Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("up34Line",0,Time[14],u34);
  }
  
 if(ObjectFind("up34Label") == -1)
  {
   ObjectCreate("up34Label", OBJ_TEXT, 0, Time[14], u34);
   ObjectSetText("up34Label",R1LineStr+ up34, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("up34Label", 0, Time[14], u34);
   ObjectSetText("up34Label",R1LineStr+ up34, 10, "Arial", lineColor);   
  }
   
///////////////////// down55 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("down55Line")==-1)
  {
   ObjectCreate("down55Line", OBJ_HLINE,0, Time[14],d55);
   ObjectSet("down55Line", OBJPROP_COLOR, lineColor);
   ObjectSet("down55Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("down55Line",0,Time[14],d55);
  }
 if(ObjectFind("down55Label") == -1)
  {
   ObjectCreate("down55Label", OBJ_TEXT, 0, Time[14], d55);
   ObjectSetText("down55Label",S2LineStr+ down55, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("down55Label", 0, Time[14], d55);
   ObjectSetText("down55Label",S2LineStr+ down55, 10, "Arial", lineColor);   
  }
//////////////////// up55 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("up55Line")==-1)
  {
   ObjectCreate("up55Line", OBJ_HLINE,0, Time[14],u55);
   ObjectSet("up55Line", OBJPROP_COLOR, lineColor);
   ObjectSet("up55Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("up55Line",0,Time[14],u55);
  }
  
 if(ObjectFind("up55Label") == -1)
  {
   ObjectCreate("up55Label", OBJ_TEXT, 0, Time[14], u55);
   ObjectSetText("up55Label",R2LineStr+ up55, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("up55Label", 0, Time[14], u55);
   ObjectSetText("up55Label",R2LineStr+ up55, 10, "Arial", lineColor);   
  }
  
////////////// down89 Line/Label /////////////////////////          
//////////////////////////////////////////////////////
 if(ObjectFind("down89Line")==-1)
  {
   ObjectCreate("down89Line", OBJ_HLINE,0, Time[14],d89);
   ObjectSet("down89Line", OBJPROP_COLOR, lineColor);
   ObjectSet("down89Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("down89Line",0,Time[14],d89);
  }
 if(ObjectFind("down89Label") == -1)
  {
   ObjectCreate("down89Label", OBJ_TEXT, 0, Time[14], d89);
   ObjectSetText("down89Label",S3LineStr+ down89, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("down89Label", 0, Time[14], d89);
   ObjectSetText("down89Label",S3LineStr+ down89, 10, "Arial", lineColor);   
  }
//////////////////// up89 Line/Label ///////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("up89Line")==-1)
  {
   ObjectCreate("up89Line", OBJ_HLINE,0, Time[14],u89);
   ObjectSet("up89Line", OBJPROP_COLOR, lineColor);
   ObjectSet("up89Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("up89Line",0,Time[14],u89);
  }
  
 if(ObjectFind("up89Label") == -1)
  {
   ObjectCreate("up89Label", OBJ_TEXT, 0, Time[14], u89);
   ObjectSetText("up89Label",R3LineStr+ up89, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("up89Label", 0, Time[14], u89);
   ObjectSetText("up89Label",R3LineStr+ up89, 10, "Arial", lineColor);   
  }        

//////////////////// down144 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("down144Line")==-1)
  {
   ObjectCreate("down144Line", OBJ_HLINE,0, Time[14],d144);
   ObjectSet("down144Line", OBJPROP_COLOR, lineColor);
   ObjectSet("down144Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("down144Line",0,Time[14],d144);
  }
 if(ObjectFind("down144Label") == -1)
  {
   ObjectCreate("down144Label", OBJ_TEXT, 0, Time[14], d144);
   ObjectSetText("down144Label",S4LineStr+ down144, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("down144Label", 0, Time[14], d144);
   ObjectSetText("down144Label",S4LineStr+ down144, 10, "Arial", lineColor);   
  }
/////////////////////up144 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("up144Line")==-1)
  {
   ObjectCreate("up144Line", OBJ_HLINE,0, Time[14],u144);
   ObjectSet("up144Line", OBJPROP_COLOR, lineColor);
   ObjectSet("up144Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("up144Line",0,Time[14],u144);
  }
  
 if(ObjectFind("up144Label") == -1)
  {
   ObjectCreate("up144Label", OBJ_TEXT, 0, Time[14], u144);
   ObjectSetText("up144Label",R4LineStr+ up144, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("up144Label", 0, Time[14], u144);
   ObjectSetText("up144Label",R4LineStr+ up144, 10, "Arial", lineColor);   
  }
   
///////////////////// down233 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("down233Line")==-1)
  {
   ObjectCreate("down233Line", OBJ_HLINE,0, Time[14],d233);
   ObjectSet("down233Line", OBJPROP_COLOR, lineColor);
   ObjectSet("down233Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("down233Line",0,Time[14],d233);
  }
 if(ObjectFind("down233Label") == -1)
  {
   ObjectCreate("down233Label", OBJ_TEXT, 0, Time[14], d233);
   ObjectSetText("down233Label",S5LineStr+ down233, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("down233Label", 0, Time[14], d233);
   ObjectSetText("down233Label",S5LineStr+ down233, 10, "Arial", lineColor);   
  }
//////////////////// up233 Line/Label////////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("up233Line")==-1)
  {
   ObjectCreate("up233Line", OBJ_HLINE,0, Time[14],u233);
   ObjectSet("up233Line", OBJPROP_COLOR, lineColor);
   ObjectSet("up233Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("up233Line",0,Time[14],u233);
  }
  
 if(ObjectFind("up233Label") == -1)
  {
   ObjectCreate("up233Label", OBJ_TEXT, 0, Time[14], u233);
   ObjectSetText("up233Label",R5LineStr+ up233, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("up233Label", 0, Time[14], u233);
   ObjectSetText("up233Label",R5LineStr+ up233, 10, "Arial", lineColor);   
  }
  
////////////// down377 Line/Label /////////////////////////          
//////////////////////////////////////////////////////
 if(ObjectFind("down377Line")==-1)
  {
   ObjectCreate("down377Line", OBJ_HLINE,0, Time[14],d377);
   ObjectSet("down377Line", OBJPROP_COLOR, lineColor);
   ObjectSet("down377Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("down377Line",0,Time[14],d377);
  }
 if(ObjectFind("down377Label") == -1)
  {
   ObjectCreate("down377Label", OBJ_TEXT, 0, Time[14], d377);
   ObjectSetText("down377Label",S6LineStr+ down377, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("down377Label", 0, Time[14], d377);
   ObjectSetText("down377Label",S6LineStr+ down377, 10, "Arial", lineColor);   
  }
//////////////////// up377 Line/Label ///////////////////
//////////////////////////////////////////////////////
 if(ObjectFind("up377Line")==-1)
  {
   ObjectCreate("up377Line", OBJ_HLINE,0, Time[14],u377);
   ObjectSet("up377Line", OBJPROP_COLOR, lineColor);
   ObjectSet("up377Line", OBJPROP_STYLE, STYLE_DASH);
  }
 else
  {
   ObjectMove("up377Line",0,Time[14],u377);
  }
  
 if(ObjectFind("up377Label") == -1)
  {
   ObjectCreate("up377Label", OBJ_TEXT, 0, Time[14], u377);
   ObjectSetText("up377Label",R6LineStr+ up377, 10, "Arial", lineColor);
  }
 else
  {
   ObjectMove("up377Label", 0, Time[14], u377);
   ObjectSetText("up377Label",R6LineStr+ up377, 10, "Arial", lineColor);   
  }   
return(0); 
}
//+------------------------------------------------------------------+----------------------------------------------------------+